#ifndef RECEIVER_DEFS_H
#define RECEIVER_DEFS_H

#include "sls_detector_defs.h"

#include <stdint.h> 

#define GOODBYE 							-200

#define DO_NOTHING		0
#define CREATE_FILES	1
#define DO_EVERYTHING	2


//all max frames defined in sls_detector_defs.h. 20000 gotthard, 100000 for short gotthard, 1000 for moench

#define GOTTHARD_FIFO_SIZE					25000
#define GOTTHARD_ALIGNED_FRAME_SIZE			4096
#define GOTTHARD_PACKETS_PER_FRAME			2
#define GOTTHARD_BUFFER_SIZE 				(1286*GOTTHARD_PACKETS_PER_FRAME)
#define GOTTHARD_DATA_BYTES	 				(1280*GOTTHARD_PACKETS_PER_FRAME)

#define GOTTHARD_SHORT_PACKETS_PER_FRAME	1
#define GOTTHARD_SHORT_BUFFER_SIZE			518
#define GOTTHARD_SHORT_DATABYTES			512

#define GOTTHARD_FRAME_INDEX_MASK			0xFFFFFFFF
#define GOTTHARD_FRAME_INDEX_OFFSET			0




#define MOENCH_FIFO_SIZE					2500
#define MOENCH_ALIGNED_FRAME_SIZE			65536
#define MOENCH_PACKETS_PER_FRAME			40
#define MOENCH_BUFFER_SIZE 					(1286*MOENCH_PACKETS_PER_FRAME)
#define MOENCH_DATA_BYTES	 				(1280*MOENCH_PACKETS_PER_FRAME)

#define MOENCH_BYTES_PER_ADC				(40*2)
#define MOENCH_PIXELS_IN_ONE_ROW			160
#define MOENCH_BYTES_IN_ONE_ROW				(MOENCH_PIXELS_IN_ONE_ROW*2)


#define MOENCH_FRAME_INDEX_MASK				0xFFFFFF00
#define MOENCH_FRAME_INDEX_OFFSET			8
#define MOENCH_PACKET_INDEX_MASK			0xFF





//#define THIS_SOFTWARE_VERSION 0x20120919
#endif
